(* $Id$ *)

let device = "/dev/ttyS0"

let main() =
  let buf = String.create 1 in
  let n = ref 0 in
  let fd = Unix.openfile device [Unix.O_RDONLY] 0 in

  (* Set non-canonical mode: *)
  let tio = Unix.tcgetattr fd in
  let tio' =
    { tio with
	(* raw mode according to Stevens *)
	Unix.c_echo = false;
	c_icanon = false;
	(* c_iexten = false; *)
	c_isig = false;
	c_brkint = false;
	c_icrnl = false;
	c_inpck = false;
	c_istrip = false;
	c_ixon = false;
	c_csize = 8;
	c_parenb = false;
	c_opost = false;
	c_vmin = 1;
	c_vtime = 0
    } in
  Unix.tcsetattr fd Unix.TCSANOW tio';

  while true do
    let k = Unix.read fd buf 0 1 in
    if k = 0 then
      prerr_endline "k=0";
    n := !n + k;
    if !n mod 512 = 0 then
      prerr_endline ("n=" ^ string_of_int !n);
  done
;;

main()
